﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Threading;
using Microsoft.Win32;
using System.IO;

namespace _2012_06_12
{
    public partial class MainWindow : Window
    {

        Thread thread;

        public MainWindow()
        {
            InitializeComponent();

            thread = new Thread(doWork);
            thread.Start();
        }

        volatile bool hasToStop = false;

        void doWork()
        {
            // TODO: Exceptions!

            FileStream fs = null;
            bool isAtEnd = true;
            long fileLength = 0;
            while (!hasToStop)
            {
                string fileNameLocal;
                bool gotNewFileLocal;
                lock (fileLock)
                {
                    fileNameLocal = fileName;
                    gotNewFileLocal = gotNewfile;
                    gotNewfile = false;
                }
                if (gotNewFileLocal)
                {
                    if(fs != null)
                    {
                        fs.Close();
                    }
                    fileLength = new FileInfo(fileNameLocal).Length;
                    fs = new FileStream(fileNameLocal, FileMode.Open);
                    isAtEnd = false;
                }

                if(!isAtEnd)
                {
                    int z = fs.ReadByte();
                    if (z == -1)
                    {
                        isAtEnd = true;
                    }
                    percentDone = 100.0f * fs.Position / fileLength;
                    // Nein! progressBar1.Value = percentDone;
                    Dispatcher.Invoke(new Action(() => progressBar1.Value = percentDone)); 
                }
                Thread.Sleep(10);
            }
            if (fs != null)
            {
                fs.Close();
            }
        }

        volatile float percentDone;

        private void Window_Closed(object sender, EventArgs e)
        {
            hasToStop = true;
            thread.Join();
        }

        OpenFileDialog ofd = new OpenFileDialog();
        string fileName;
        bool gotNewfile = false;
        object fileLock = new object();

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            if (ofd.ShowDialog() == true)
            {
                lock (fileLock)
                {
                    fileName = ofd.FileName;
                    gotNewfile = true;
                }
            }
        }
    }
}
